searchNodes=[{"doc":"This Library provides everything you need to route requests and websockets from one proxy app into your umbrella. This allows you to have multiple phoenix applications in the same umbrella sharing the same port number.Start by creating a Phoenix application in your umbrella apps folder:(cd apps &amp;&amp; mix phx.new --no-webpack --no-ecto --no-html --no-gettext --no-dashboard reverse_proxy) # Optionally you can delete unused files rm -rf apps/reverse_proxy/lib/reverse_proxy_web/{channels,controllers,views}In apps/reverse_proxy/lib/reverse_proxy_web/endpoint.ex replace the contents with this and replace the default endpoint and add appropriate endpoints:defmodule ReverseProxyWeb.Endpoint do use PhoenixReverseProxy, otp_app: :reverse_proxy # IMPORTANT: All of these macros except for proxy_default/1 # can take a path prefix so they all have an arity # of 2 and 3. # Maps to http(s)://api.example.com/v1 # proxy(&quot;api.example.com&quot;, &quot;v1&quot;, ExampleApiV1.Endpoint) # Maps to http(s)://api.example.com/v2 # proxy(&quot;api.example.com&quot;, &quot;v2&quot;, ExampleApiV2.Endpoint) # Matches the domain only and no subdomains # proxy(&quot;example.com&quot;, ExampleWeb.Endpoint) # Matched any subdomain such as http(s)://images.example.com/ # but not the domain itself http(s)://example.com/ # proxy_subdomains(&quot;example.com&quot;, ExampleSubs.Endpoint) # Matches all subdomains and the domain itself. # This is equivalent to combining these rules: # proxy(&quot;foofoovalve.com&quot;, FoofooValve.Endpoint) # proxy_subdomains(&quot;foofoovalve.com&quot;, FoofooValve.Endpoint) # proxy_all(&quot;foofoovalve.com&quot;, FoofooValve.Endpoint) # Matches anything not matched above proxy_default(ExampleWeb.Endpoint) endIn your config you must disable your other Phoenix applications from listening on TCP ports. In your current endpoint configuration make the following modifications.# Configures the endpoint config :example_web, ExampleWeb.Endpoint, # Add this server: false, # Remove this and add it to the proxy endpoint configuration http: [port: System.get_env(&quot;PHX_PORT&quot;) || 4000], ...Move contents of the files apps/reverse_proxy/config/*.exs to the corresponding config/*.exs config files.","ref":"PhoenixReverseProxy.html","title":"PhoenixReverseProxy","type":"module"},{"doc":"Sets the Phoenix endpoint for a specific hostname. Note that more specific matches are matched first regardless of the order in which they are specified.Examplesproxy(&quot;example.com&quot;, ExampleWeb.Endpoint) proxy(&quot;example.com&quot;, &quot;oauth&quot;, OAuthWeb.Endpoint) # This matches first","ref":"PhoenixReverseProxy.html#proxy/2","title":"PhoenixReverseProxy.proxy/2","type":"macro"},{"doc":"Sets the Phoenix endpoint for a specific hostname and first component of the path. Note that more specific matches are matched first regardless of the order in which they are specified.Examplesproxy(&quot;example.com&quot;, ExampleWeb.Endpoint) # For http(s)://example.com/oauth proxy(&quot;example.com&quot;, &quot;oauth&quot;, OAuthWeb.Endpoint) # This matches first","ref":"PhoenixReverseProxy.html#proxy/3","title":"PhoenixReverseProxy.proxy/3","type":"macro"},{"doc":"Sets the Phoenix endpoint for a set of subdomains including the domain itself. Note that more specific matches are matched first regardless of the order in which they are specified.Examplesproxy_all(&quot;example.com&quot;, OAuthWeb.Endpoint) # Which is equivalent to: proxy(&quot;example.com&quot;, OAuthWeb.Endpoint) proxy_subdomains(&quot;example.com&quot;, OAuthWeb.Endpoint)","ref":"PhoenixReverseProxy.html#proxy_all/2","title":"PhoenixReverseProxy.proxy_all/2","type":"macro"},{"doc":"Sets the Phoenix endpoint for a set of subdomains including the domain itself as well as the first component of the path. Note that more specific matches are matched first regardless of the order in which they are specified.Examplesproxy_all(&quot;example.com&quot;, &quot;oauth&quot;, OAuthWeb.Endpoint) # Which is equivalent to: proxy(&quot;example.com&quot;, &quot;oauth&quot;, OAuthWeb.Endpoint) proxy_subdomains(&quot;example.com&quot;, &quot;oauth&quot;, OAuthWeb.Endpoint)","ref":"PhoenixReverseProxy.html#proxy_all/3","title":"PhoenixReverseProxy.proxy_all/3","type":"macro"},{"doc":"Sets the default Phoenix endpoint to send requests to if we cannot match against anything.Examplesproxy_default(ExampleWeb.Endpoint)","ref":"PhoenixReverseProxy.html#proxy_default/1","title":"PhoenixReverseProxy.proxy_default/1","type":"macro"},{"doc":"Sets the Phoenix endpoint for a specific first component of a path. Note that more specific matches are matched first regardless of the order in which they are specified.Examplesproxy_path(&quot;auth&quot;, AuthWeb.Endpoint)","ref":"PhoenixReverseProxy.html#proxy_path/2","title":"PhoenixReverseProxy.proxy_path/2","type":"macro"},{"doc":"Sets the Phoenix endpoint for a set of subdomains excluding the domain itself. Note that more specific matches are matched first regardless of the order in which they are specified.Examplesproxy_subdomains(&quot;example.com&quot;, ExampleWeb.Endpoint)","ref":"PhoenixReverseProxy.html#proxy_subdomains/2","title":"PhoenixReverseProxy.proxy_subdomains/2","type":"macro"},{"doc":"Sets the Phoenix endpoint for a set of subdomains excluding the domain itself as well as the first component of the path. Note that more specific matches are matched first regardless of the order in which they are specified.Examplesproxy_subdomains(&quot;example.com&quot;, &quot;oauth&quot;, OAuthWeb.Endpoint)","ref":"PhoenixReverseProxy.html#proxy_subdomains/3","title":"PhoenixReverseProxy.proxy_subdomains/3","type":"macro"},{"doc":"Reverse a domain name string (ASCII). This is used internally for pattern matching of subdomains.Examplesiex&gt; PhoenixReverseProxy.reverse_domain(&quot;abc.com&quot;) &quot;moc.cba&quot;","ref":"PhoenixReverseProxy.html#reverse_domain/1","title":"PhoenixReverseProxy.reverse_domain/1","type":"function"},{"doc":"PhoenixReverseProxyShare a port between many Phoenix apps in an umbrella","ref":"readme.html","title":"PhoenixReverseProxy","type":"extras"},{"doc":"This Library provides everything you need to route requests and websockets from one proxy app into your umbrella. This allows you to have multiple phoenix applications in the same umbrella sharing the same port number.Start by creating a Phoenix application in your umbrella apps folder: (cd apps &amp;&amp; mix phx.new --no-webpack --no-ecto --no-html --no-gettext --no-dashboard reverse_proxy) # Optionally you can delete unused files rm -rf apps/reverse_proxy/lib/reverse_proxy_web/{channels,controllers,views}If available in Hex, the package can be installed by adding phoenix_reverse_proxy to your list of dependencies in mix.exs:def deps do [ {:phoenix_reverse_proxy, &quot;~&gt; 1.0.0&quot;} ] endIn apps/reverse_proxy/lib/reverse_proxy_web/endpoint.ex replace the contents with this and replace the default endpoint and add appropriate endpoints: defmodule ReverseProxyWeb.Endpoint do use PhoenixReverseProxy, otp_app: :reverse_proxy # IMPORTANT: All of these macros except for proxy_default/1 # can take a path prefix so they all have an arity # of 2 and 3. # Maps to http(s)://api.example.com/v1 proxy(&quot;api.example.com&quot;, &quot;v1&quot;, ExampleApiV1.Endpoint) # Maps to http(s)://api.example.com/v2 proxy(&quot;api.example.com&quot;, &quot;v2&quot;, ExampleApiV2.Endpoint) # Matches the domain only and no subdomains proxy(&quot;example.com&quot;, ExampleWeb.Endpoint) # Matched any subdomain such as http(s)://images.example.com/ # but not the domain itself http(s)://example.com/ proxy_subdomains(&quot;example.com&quot;, ExampleSubs.Endpoint) # Matches all subdomains and the domain itself. # This is equivalent to combining these rules: # proxy(&quot;foofoovalve.com&quot;, FoofooValve.Endpoint) # proxy_subdomains(&quot;foofoovalve.com&quot;, FoofooValve.Endpoint) proxy_all(&quot;foofoovalve.com&quot;, FoofooValve.Endpoint) # Matches anything not matched above proxy_default(ExampleWeb.Endpoint) endIn your config you must disable your other Phoenix applications from listening on TCP ports. In your current endpoint configuration make the following modifications. # Configures the endpoint config :example_web, ExampleWeb.Endpoint, # Add this server: false, # Remove this and add it to the proxy endpoint configuration http: [port: System.get_env(&quot;PHX_PORT&quot;) || 4000], ...Move contents of the files apps/reverse_proxy/config/*.exs to the corresponding config/*.exs config files.Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/phoenix_reverse_proxy.","ref":"readme.html#setup","title":"PhoenixReverseProxy - Setup","type":"extras"}]